import pygame, random, sys, time
from pygame.locals import *
import cPickle as p

pygame.init()

# create window
screenresolution=(700,700)
window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
fullscreen=True

#set up font
font = pygame.font.SysFont(None, 40)

# main game
def playgame(gamename, window, font, fullscreen):

	#import variables from saved file
	
	try:
		f = file(gamename)
		variables = p.load(f)
		f.close()
	
	except:
		
		 #insert error text into window
		screenresolution=(700,700)
		window.fill((0,0,0))
		errormessage = font.render('There was a problem loading the game.', True, (255,255,255), (0,0,0))
		messageRect = errormessage.get_rect()
		messageRect.centerx = screenresolution[0]/2
		messageRect.centery = screenresolution[1]/2
		window.blit(errormessage, messageRect)
		
		pygame.display.update()
		
		print 'there was a problem loading the game'
		
		time.sleep(1.5)
		#menu()
	
	#load images
	grill=pygame.image.load('images/grill.png')	
	lair=pygame.image.load('images/lair.png')	
	lair.set_colorkey((255,255,255))
	pipe=pygame.image.load('images/pipes.png')	
	pipe.set_colorkey((255,255,255))
	scientist=pygame.image.load('images/scientist.png')	
	scientist.set_colorkey((255,255,255))
	
	buttonEXIT=pygame.image.load('images/buttonEXIT.png')	
	buttonSAVE=pygame.image.load('images/buttonSAVE.png')	
	buttonWEAPONS=pygame.image.load('images/buttonWEAPONS.png')	
	buttonCARS=pygame.image.load('images/buttonCARS.png')	
	buttonMEN=pygame.image.load('images/buttonMEN.png')	
	buttonINVASION=pygame.image.load('images/buttonINVASION.png')	
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
	buttonHIGHLIGHTED.set_colorkey((255,255,255))
	
	#positions of decorative objects
	grills=[pygame.Rect(123,267,1,1),pygame.Rect(500,412,1,1),pygame.Rect(320,610,1,1)]
	pipes=[pygame.Rect(123,0,1,1),pygame.Rect(456,0,1,1),pygame.Rect(333,0,1,1)]
	
	guyY = 350
	
	#buttons
	class button():
		def __init__(self,image,pos,function):
			self.image=image
			self.pos=pos
			self.function=function
			
	buttons=[]
	buttons.append(button(buttonEXIT,pygame.Rect(649,649,50,50),'exit'))
	buttons.append(button(buttonSAVE,pygame.Rect(597,649,50,50),'save'))
	buttons.append(button(buttonWEAPONS,pygame.Rect(1,649,50,50),'buy weapons'))
	buttons.append(button(buttonCARS,pygame.Rect(53,649,50,50),'buy cars'))
	buttons.append(button(buttonMEN,pygame.Rect(105,649,50,50),'buy men'))
	buttons.append(button(buttonINVASION,pygame.Rect(157,649,50,50),'invasion'))
	
	currentfunction = ''
	
	#weapons
	class weapon():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			
	weapons=[]
	
	#cars
	class car():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			
	cars=[]
	
	#men
	class man():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			
	men=[]
	
	#countries
	
	class country():
		def __init__(self,name,pos,defence,population):
			self.name=name
			self.pos=pos
			self.defence=defence
			self.population=population
			
	countries=[]
	
	countries.append(country('South Africa',pygame.Rect(563,500,7,7),1000,1000))
	countries.append(country('Sun',pygame.Rect(570,100,7,7),1000000,1000000))
	countries.append(country('Moon',pygame.Rect(50,100,7,7),100000,100000))
	countries.append(country('India',pygame.Rect(81,481,7,7),2000,10000))
	countries.append(country('U.S.A',pygame.Rect(400,360,7,7),5000,10000))
	countries.append(country('Australia',pygame.Rect(200,550,7,7),3000,2000))
	countries.append(country('Greenland',pygame.Rect(490,310,7,7),100,100))
	countries.append(country('Antarctica',pygame.Rect(350,590,7,7),10,10))
	countries.append(country('Brazil',pygame.Rect(430,480,7,7),1000,1000))
	countries.append(country('France',pygame.Rect(563,340,7,7),2000,2000))
	countries.append(country('Canada',pygame.Rect(410,310,7,7),2500,2000))
	countries.append(country('China',pygame.Rect(190,390,7,7),50000,50000))
	countries.append(country('Russia',pygame.Rect(150,370,7,7),3000,3000))
	countries.append(country('Christmas land',pygame.Rect(320,240,7,7),70000,111111))
	
	#banks
	
	class bank():
		def __init__(self,name,pos,defence,money):
			self.name=name
			self.pos=pos
			self.defence=defence
			self.money=money
			
	banks=[]
	
	banks.append(bank('South Africa',pygame.Rect(563,460,7,7),1000,1000))
	banks.append(bank('India',pygame.Rect(81,401,7,7),2000,2000))
	banks.append(bank('U.S.A',pygame.Rect(400,330,7,7),3000,3000))
	banks.append(bank('Australia',pygame.Rect(230,550,7,7),4000,4000))
	banks.append(bank('Greenland',pygame.Rect(490,325,7,7),5000,5000))
	banks.append(bank('Antarctica',pygame.Rect(370,590,7,7),6000,6000))
	banks.append(bank('Brazil',pygame.Rect(430,500,7,7),7000,7000))
	banks.append(bank('France',pygame.Rect(583,340,7,7),8000,8000))
	banks.append(bank('Canada',pygame.Rect(450,340,7,7),9000,9000))
	banks.append(bank('China',pygame.Rect(100,330,7,7),10000,10000))
	banks.append(bank('Russia',pygame.Rect(100,390,7,7),11000,11000))
	banks.append(bank('Christmas land',pygame.Rect(350,240,7,7),12000,12000))
			
	#gameloop
	gamerunning = True
	while gamerunning==True:
		
		guyY = guyY%350
	
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
				if event.key==K_UP:
					guyY-=5
				if event.key==K_DOWN:
					guyY+=5
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				for i in buttons:
					if i.pos.collidepoint(event.pos[0],event.pos[1])==True:
						currentfunction=i.function
										
		# draw graphics
		window.fill((127,127,127))
		window.blit(lair, (0,0))
		for i in grills:
			window.blit(grill, i)
		for i in pipes:
			window.blit(pipe, i)
		
		window.blit(scientist,(5,200+guyY))	
		
			#draw control panel
		pygame.draw.rect(window, (0,0,100), (0, 648, 700,52))
		for i in buttons:
			window.blit(i.image,i.pos)
			if i.pos.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(buttonHIGHLIGHTED, i.pos)
		
		money = font.render('$'+str(variables['cash']), True, (255,255,255), (0,0,100))
		moneyRect = money.get_rect()
		moneyRect.topleft = (300,660)
		window.blit(money, moneyRect)	
			
		pygame.display.update()
		
		#income
		if random.randint(0,1000)==1:
			for i in variables['countries inslaved']:
				for j in countries:
					if j.name == i:
						variables['cash']+=(j.population/10)
		
		#functions
		if currentfunction=='exit':
			exit(window,font,button,variables,gamename,fullscreen)
			
		if currentfunction=='save':
			save(window,font,variables,gamename)
			
		if currentfunction=='buy weapons':
			buyweapons(window,font,variables,weapons,gamename,fullscreen)
			
		if currentfunction=='buy men':
			buymen(window,font,variables,men,gamename,fullscreen)
			
		if currentfunction=='buy cars':
			buycars(window,font,variables,cars,gamename,fullscreen)
			
		if currentfunction=='invasion':
			invasion(window,font,variables,cars,men,weapons,gamename,fullscreen,countries,country,banks,bank)
			
		currentfunction = ''

def exit(window,font,button,variables,gamename,fullscreen):
	while True:
		#load buttons
		buttonYES=pygame.image.load('images/buttonYES.png')	
		buttonYES.set_colorkey((255,255,255))
		buttonNO=pygame.image.load('images/buttonNO.png')	
		buttonNO.set_colorkey((255,255,255))
		buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
		buttonHIGHLIGHTED.set_colorkey((255,255,255))
	
		yes=button(buttonYES,pygame.Rect(290,400,50,50),'yes')
		no=button(buttonNO,pygame.Rect(360,400,50,50),'yes')
		
		#draw text
		savemessage = font.render('Save before exiting?', True, (255,255,255), (0,0,0))
		messageRect = savemessage.get_rect()
		messageRect.centerx = 350
		messageRect.centery = 350
		
		pygame.draw.rect(window, (0,0,0), (200,200,300,300))
		window.blit(savemessage, messageRect)
			
		window.blit(yes.image,yes.pos)
		if yes.pos.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(buttonHIGHLIGHTED, yes.pos)
		window.blit(no.image,no.pos)
		if no.pos.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(buttonHIGHLIGHTED, no.pos)
		
		pygame.display.update()	
		
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				if no.pos.collidepoint(event.pos[0],event.pos[1])==True:
					menu(window, font, fullscreen)
				if yes.pos.collidepoint(event.pos[0],event.pos[1])==True:
					save(window,font,variables,gamename)
					menu(window, font, fullscreen)
					
def menu(window, font, fullscreen):
	#playgame('game1.data', window, font, fullscreen)
	
	#load images
	buttonimage=pygame.image.load('images/button.png')	
	buttonHIGHLIGHTED=pygame.image.load('images/menubuttonHIGHLIGHTED.png')	
	background=pygame.image.load('images/earth.png')	
	
	class button():
		def __init__(self,function,image,pos):
			self.function=function
			self.image=image
			self.pos=pos
			
	buttons=[]
	
	buttons.append(button('GAME1',buttonimage,pygame.Rect(50,25,300,50)))
	buttons.append(button('GAME2',buttonimage,pygame.Rect(50,125,300,50)))
	buttons.append(button('GAME3',buttonimage,pygame.Rect(50,225,300,50)))
	buttons.append(button('GAME4',buttonimage,pygame.Rect(50,325,300,50)))
	buttons.append(button('GAME5',buttonimage,pygame.Rect(50,425,300,50)))
	buttons.append(button('INSTRUCTIONS',buttonimage,pygame.Rect(50,525,300,50)))
	buttons.append(button('EXIT',buttonimage,pygame.Rect(50,625,300,50)))
	
	currentfunction=''
	
	while True:
	
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				for i in buttons:
					if i.pos.collidepoint((event.pos[0],event.pos[1]))==True:
						currentfunction=i.function
		
		#graphics
		window.fill((0,0,100))
		
		window.blit(background,(400,0))
		
		for i in buttons:
			window.blit(i.image,i.pos)		
			if i.pos.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(buttonHIGHLIGHTED, i.pos)
				
			text = font.render(i.function, True, (255,255,255), (0,0,100))
			textRect = text.get_rect()
			textRect.topleft = (i.pos[0]+9,i.pos[1]+10)
			window.blit(text, textRect)	
	
		pygame.display.update()	
			
		if 'GAME' in currentfunction:
			playgame(str(currentfunction)+'.data', window, font, fullscreen)
			
		if currentfunction=='INSTRUCTIONS':
			instructions(window,fullscreen)
			
		if currentfunction=='EXIT':
			pygame.quit()
			sys.exit()
			
def save(window,font,variables,gamename):
	f = file(gamename, 'w')
	p.dump(variables, f)
	f.close()
	print 'saving'
	
	buttonSAVE=pygame.image.load('images/buttonSAVE2.png')	
	window.blit(buttonSAVE, (325,325,1,1))
	pygame.display.update()
	time.sleep(0.5)

def buymen(window,font,variables,men,gamename,fullscreen):
	
	#load images
	
	ninja=pygame.image.load('images/ninja.png')	
	mobster=pygame.image.load('images/mobster.png')	
	clown=pygame.image.load('images/clown.png')	
	ruffian=pygame.image.load('images/ruffian.png')	
	henchman=pygame.image.load('images/henchman.png')
	plus=pygame.image.load('images/plus.png')
	plus2=pygame.image.load('images/plus2.png')
	exit=pygame.image.load('images/buttonEXIT.png')	
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
	buttonHIGHLIGHTED.set_colorkey((255,255,255))	
	
	#men
	class man():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			self.cost=cost
			
	plusses=[]
	for i in range(5):
		plusses.append(pygame.Rect(160,210+i*100,10,10))
		
	exitRect=pygame.Rect(600,50,50,50)
			
	men=[]
	men.append(man('Ninja','ninja',1000,1000))
	men.append(man('Mobster','mobster',500,300))
	men.append(man('Henchman','henchman',400,200))
	men.append(man('Ruffian','ruffian',400,200))
	men.append(man('Clown','clown',10,1))
	
	shopping = True
	while shopping==True:
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				for i in range(len(plusses)):
					if plusses[i].collidepoint(event.pos[0],event.pos[1])==True:
						if variables['cash'] >= men[i].cost:
							variables['men'].append(i)
							variables['cash'] -= men[i].cost
				if exitRect.collidepoint(event.pos[0],event.pos[1])==True:
					shopping = False
				
		#draw graphics
		window.fill((0,0,100))
		for i in range(len(men)):
			if men[i].image == 'ninja':
				window.blit(ninja, (100,200+i*100,1,1))
			if men[i].image == 'mobster':
				window.blit(mobster, (100,200+i*100,1,1))
			if men[i].image == 'henchman':
				window.blit(henchman, (100,200+i*100,1,1))
			if men[i].image == 'ruffian':
				window.blit(ruffian, (100,200+i*100,1,1))
			if men[i].image == 'clown':
				window.blit(clown, (100,200+i*100,1,1))
			#write name and cost
			name = font.render(men[i].name, True, (255,255,255), (0,0,100))
			nameRect = name.get_rect()
			nameRect.topleft = (200,200+i*100)
			window.blit(name, nameRect)
			
			cost = font.render(str(men[i].cost), True, (255,255,255), (0,0,100))
			costRect = cost.get_rect()
			costRect.topleft = (500,200+i*100)
			window.blit(cost,costRect)
		
		for i in plusses:
			window.blit(plus,i)
			if i.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(plus2, i)
			
		money = font.render('$'+str(variables['cash']), True, (255,255,255), (0,0,100))
		moneyRect = money.get_rect()
		moneyRect.topleft = (100,50)
		window.blit(money, moneyRect)	
		
		window.blit(exit, exitRect)	
		if exitRect.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(buttonHIGHLIGHTED, exitRect)
				
		pygame.display.update()

def buyweapons(window,font,variables,weapons,gamename,fullscreen):
	
	#load images
	
	nuclearmissile=pygame.image.load('images/nuclearmissile.png')	
	plaguemissile=pygame.image.load('images/plaguemissile.png')	
	electronicblackout=pygame.image.load('images/electronicblackout.png')	
	missile=pygame.image.load('images/missile.png')	
	waterballoon=pygame.image.load('images/waterballoon.png')
	plus=pygame.image.load('images/plus.png')
	plus2=pygame.image.load('images/plus2.png')
	exit=pygame.image.load('images/buttonEXIT.png')	
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
	buttonHIGHLIGHTED.set_colorkey((255,255,255))	
	
	#weapons
	class weapon():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			self.cost=cost
			
	plusses=[]
	for i in range(5):
		plusses.append(pygame.Rect(160,210+i*100,10,10))
		
	exitRect=pygame.Rect(600,50,50,50)
			
	weapons=[]
	weapons.append(weapon('Nuclear missile','nuclearmissile',1000,10000))
	weapons.append(weapon('Plague missile','plaguemissile',500,3000))
	weapons.append(weapon('Electronic blackout','electronicblackout',400,2000))
	weapons.append(weapon('Missile','missile',400,2000))
	weapons.append(weapon('Water balloon','waterballoon',10,1))
	
	shopping = True
	while shopping==True:
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				for i in range(len(plusses)):
					if plusses[i].collidepoint(event.pos[0],event.pos[1])==True:
						if variables['cash'] >= weapons[i].cost:
							variables['weapons'].append(i)
							variables['cash'] -= weapons[i].cost
				if exitRect.collidepoint(event.pos[0],event.pos[1])==True:
					shopping = False
				
		#draw graphics
		window.fill((0,0,100))
		for i in range(len(weapons)):
			if weapons[i].image == 'nuclearmissile':
				window.blit(nuclearmissile, (100,200+i*100,1,1))
			if weapons[i].image == 'plaguemissile':
				window.blit(plaguemissile, (100,200+i*100,1,1))
			if weapons[i].image == 'electronicblackout':
				window.blit(electronicblackout, (100,200+i*100,1,1))
			if weapons[i].image == 'missile':
				window.blit(missile, (100,200+i*100,1,1))
			if weapons[i].image == 'waterballoon':
				window.blit(waterballoon, (100,200+i*100,1,1))
			#write name and cost
			name = font.render(weapons[i].name, True, (255,255,255), (0,0,100))
			nameRect = name.get_rect()
			nameRect.topleft = (200,200+i*100)
			window.blit(name, nameRect)
			
			cost = font.render(str(weapons[i].cost), True, (255,255,255), (0,0,100))
			costRect = cost.get_rect()
			costRect.topleft = (500,200+i*100)
			window.blit(cost,costRect)
		
		for i in plusses:
			window.blit(plus,i)
			if i.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(plus2, i)
			
		money = font.render('$'+str(variables['cash']), True, (255,255,255), (0,0,100))
		moneyRect = money.get_rect()
		moneyRect.topleft = (100,50)
		window.blit(money, moneyRect)	
		
		window.blit(exit, exitRect)	
		if exitRect.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(buttonHIGHLIGHTED, exitRect)
				
		pygame.display.update()
	
	
def buycars(window,font,variables,cars,gamename,fullscreen):
	
	#load images
	
	plane=pygame.image.load('images/plane.png')	
	tank=pygame.image.load('images/tank.png')	
	helicopter=pygame.image.load('images/helicopter.png')	
	armouredtruck=pygame.image.load('images/armouredtruck.png')	
	bicycle=pygame.image.load('images/bicycle.png')
	plus=pygame.image.load('images/plus.png')
	plus2=pygame.image.load('images/plus2.png')
	exit=pygame.image.load('images/buttonEXIT.png')	
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
	buttonHIGHLIGHTED.set_colorkey((255,255,255))	
	
	#cars
	class car():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			self.cost=cost
			
	plusses=[]
	for i in range(5):
		plusses.append(pygame.Rect(160,210+i*100,10,10))
		
	exitRect=pygame.Rect(600,50,50,50)
			
	cars=[]
	cars.append(car('Plane','plane',1000,10000))
	cars.append(car('Tank','tank',500,3000))
	cars.append(car('Helicopter','helicopter',400,2000))
	cars.append(car('Armoured truck','armouredtruck',400,2000))
	cars.append(car('Bicycle','bicycle',10,1))
	
	shopping = True
	while shopping==True:
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				for i in range(len(plusses)):
					if plusses[i].collidepoint(event.pos[0],event.pos[1])==True:
						if variables['cash'] >= cars[i].cost:
							variables['cars'].append(i)
							variables['cash'] -= cars[i].cost
				if exitRect.collidepoint(event.pos[0],event.pos[1])==True:
					shopping = False
				
		#draw graphics
		window.fill((0,0,100))
		for i in range(len(cars)):
			if cars[i].image == 'plane':
				window.blit(plane, (100,200+i*100,1,1))
			if cars[i].image == 'tank':
				window.blit(tank, (100,200+i*100,1,1))
			if cars[i].image == 'helicopter':
				window.blit(helicopter, (100,200+i*100,1,1))
			if cars[i].image == 'armouredtruck':
				window.blit(armouredtruck, (100,200+i*100,1,1))
			if cars[i].image == 'bicycle':
				window.blit(bicycle, (100,200+i*100,1,1))
			#write name and cost
			name = font.render(cars[i].name, True, (255,255,255), (0,0,100))
			nameRect = name.get_rect()
			nameRect.topleft = (200,200+i*100)
			window.blit(name, nameRect)
			
			cost = font.render(str(cars[i].cost), True, (255,255,255), (0,0,100))
			costRect = cost.get_rect()
			costRect.topleft = (500,200+i*100)
			window.blit(cost,costRect)
		
		for i in plusses:
			window.blit(plus,i)
			if i.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(plus2, i)
			
		money = font.render('$'+str(variables['cash']), True, (255,255,255), (0,0,100))
		moneyRect = money.get_rect()
		moneyRect.topleft = (100,50)
		window.blit(money, moneyRect)	
		
		window.blit(exit, exitRect)	
		if exitRect.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(buttonHIGHLIGHTED, exitRect)
				
		pygame.display.update()

def invasion(window,font,variables,cars,men,weapons,gamename,fullscreen,countries,country,banks,bank):	
		
	# set up weapons
		#load images
	
	nuclearmissile=pygame.image.load('images/nuclearmissile.png')	
	plaguemissile=pygame.image.load('images/plaguemissile.png')	
	electronicblackout=pygame.image.load('images/electronicblackout.png')	
	missile=pygame.image.load('images/missile.png')	
	waterballoon=pygame.image.load('images/waterballoon.png')
	plus=pygame.image.load('images/plus.png')
	exit=pygame.image.load('images/buttonEXIT.png')
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
	buttonHIGHLIGHTED.set_colorkey((255,255,255))		
	
		#weapons
	class weapon():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			self.cost=cost

	weapons=[]
	weapons.append(weapon('Nuclear missile','nuclearmissile',1000,10000))
	weapons.append(weapon('Plague missile','plaguemissile',500,3000))
	weapons.append(weapon('Electronic blackout','electronicblackout',400,2000))
	weapons.append(weapon('Missile','missile',400,2000))
	weapons.append(weapon('Water balloon','waterballoon',10,1))

	#cars
	class car():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			self.cost=cost
			
	cars=[]
	cars.append(car('Plane','plane',1000,10000))
	cars.append(car('Tank','tank',500,3000))
	cars.append(car('Helicopter','helicopter',400,2000))
	cars.append(car('Armoured truck','armouredtruck',400,2000))
	cars.append(car('Bicycle','bicycle',10,1))
	
	#men
	class man():
		def __init__(self,name,image,damage,cost):
			self.name=name
			self.image=image
			self.damage=damage
			self.cost=cost
			
	men=[]
	men.append(man('Ninja','ninja',1000,1000))
	men.append(man('Mobster','mobster',500,300))
	men.append(man('Henchman','henchman',400,200))
	men.append(man('Ruffian','ruffian',400,200))
	men.append(man('Clown','clown',10,1))

	#set up cars
	
	#set up men
	
	#INVASION
	
	#load images
	earth=pygame.image.load('images/earth.png')	
	exit=pygame.image.load('images/buttonEXIT2.png')	
	point=pygame.image.load('images/point.png')	
	point.set_colorkey((255,255,255))
	point2=pygame.image.load('images/point2.png')	
	point2.set_colorkey((255,255,255))
	point3=pygame.image.load('images/point3.png')	
	point3.set_colorkey((255,255,255))
	flag=pygame.image.load('images/flag.png')	
	flag.set_colorkey((255,255,255))
	
	exitRect=pygame.Rect(600,600,50,50)
	
	invade=True
	while invade==True:
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				if exitRect.collidepoint(event.pos[0],event.pos[1])==True:
					invade=False
					
				for land in countries:
					a=0
					for i in variables['countries inslaved']:
						if land.name==i:
							a+=1
					if a == 0:
						if land.pos.collidepoint(event.pos[0],event.pos[1]):
							invasionplan(variables,window,fullscreen,font,land,weapons,weapon,cars,car,men,gamename,countries,country)
							
				for target in banks:
					a=0
					for i in variables['banks robbed']:
						if target.name==i:
							a+=1
					if a == 0:
						if target.pos.collidepoint(event.pos[0],event.pos[1]):
							robberyplan(variables,window,fullscreen,font,target,men,man,gamename,banks,bank)
							
	
		#draw graphics
		window.blit(earth, (0,0,700,700))	
		
		for i in countries:
			a=0
			for j in variables['countries inslaved']:
				if i.name==j:
					a+=1
			if a == 0:
				window.blit(point, i.pos)
				if i.pos.collidepoint(pygame.mouse.get_pos())==True:
					window.blit(point2, i.pos)
					
			else:
				window.blit(flag, i.pos)
		
		for i in banks:
			a=0
			for j in variables['banks robbed']:
				if i.name==j:
					a+=1
			if a == 0:
				window.blit(point3, i.pos)
				if i.pos.collidepoint(pygame.mouse.get_pos())==True:
					window.blit(point2, i.pos)		
						
		window.blit(exit, exitRect)	
		if exitRect.collidepoint(pygame.mouse.get_pos())==True:
			window.blit(buttonHIGHLIGHTED, exitRect)
		
		pygame.display.update()
	
def invasionplan(variables,window,fullscreen,font,land,weapons,weapon,cars,car,men,gamename,countries,country):

	#load images
	plane=pygame.image.load('images/plane.png')	
	tank=pygame.image.load('images/tank.png')	
	helicopter=pygame.image.load('images/helicopter.png')	
	armouredtruck=pygame.image.load('images/armouredtruck.png')	
	bicycle=pygame.image.load('images/bicycle.png')
	nuclearmissile=pygame.image.load('images/nuclearmissile.png')	
	plaguemissile=pygame.image.load('images/plaguemissile.png')	
	electronicblackout=pygame.image.load('images/electronicblackout.png')	
	missile=pygame.image.load('images/missile.png')	
	waterballoon=pygame.image.load('images/waterballoon.png')
	exit=pygame.image.load('images/buttonEXIT.png')	
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
	buttonHIGHLIGHTED.set_colorkey((255,255,255))
	buttonATTACK=pygame.image.load('images/buttonATTACK.png')	
	buttonATTACK2=pygame.image.load('images/buttonATTACK2.png')
	plus=pygame.image.load('images/plus.png')
	plus2=pygame.image.load('images/plus2.png')	
	minus=pygame.image.load('images/minus.png')
	minus2=pygame.image.load('images/minus2.png')	
	
	exitRect=pygame.Rect(600,600,50,50)
	
	ATTACKRect=pygame.Rect(500,50,150,50)

	# count weapons
	
	amount_weapons=[0,0,0,0,0]
	for i in range(5):
		for j in variables['weapons']:
			if j==i:
				amount_weapons[i]+=1

	class weaponbutton():
		def __init__(self,WEAPON,pos,Ramount,Lamount,plus,minus):
			self.WEAPON=WEAPON
			self.pos=pos
			self.Ramount=Ramount
			self.Lamount=Lamount
			self.plus=plus
			self.minus=minus
	
	Wbuttons=[]
	for i in range(5):
		Wbuttons.append(weaponbutton(weapons[i],pygame.Rect(150,i*75+250,50,50),0,amount_weapons[i],pygame.Rect(225,i*75+270,10,10),pygame.Rect(115,i*75+270,10,10)))		
	
	# count cars
	
	amount_cars=[0,0,0,0,0]
	for i in range(5):
		for j in variables['cars']:
			if j==i:
				amount_cars[i]+=1

	class carbutton():
		def __init__(self,car,pos,Ramount,Lamount,plus,minus):
			self.car=car
			self.pos=pos
			self.Ramount=Ramount
			self.Lamount=Lamount
			self.plus=plus
			self.minus=minus
	
	Cbuttons=[]
	for i in range(5):
		Cbuttons.append(carbutton(cars[i],pygame.Rect(450,i*75+250,50,50),0,amount_cars[i],pygame.Rect(525,i*75+270,10,10),pygame.Rect(415,i*75+270,10,10)))		
		
		
		'''		
	plusses=[]
	for i in range(5):
		plusses.append(pygame.Rect(160,210+i*100,10,10))
		'''
	
	invade=True
	while invade==True:
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				if exitRect.collidepoint(event.pos[0],event.pos[1])==True:
					invade=False
					
				for i in Wbuttons:
					if i.plus.collidepoint(event.pos[0],event.pos[1])==True:
						if i.Lamount>0:
							i.Lamount-=1
							i.Ramount+=1
					if i.minus.collidepoint(event.pos[0],event.pos[1])==True:
						if i.Ramount>0:
							i.Ramount-=1
							i.Lamount+=1
							
				for i in Cbuttons:
					if i.plus.collidepoint(event.pos[0],event.pos[1])==True:
						if i.Lamount>0:
							i.Lamount-=1
							i.Ramount+=1
					if i.minus.collidepoint(event.pos[0],event.pos[1])==True:
						if i.Ramount>0:
							i.Ramount-=1
							i.Lamount+=1
							
				if ATTACKRect.collidepoint(event.pos[0],event.pos[1])==True:
					print
					print variables['weapons']
					variables['weapons']=[]
					amount_weapons=[0,0,0,0,0]
					for i in range(len(Wbuttons)):
						amount_weapons[i]+=Wbuttons[i].Lamount
					
					for i in range(len(amount_weapons)):
						for j in range(amount_weapons[i]):
							variables['weapons'].append(i)	
						
					print variables['weapons']
					print
					
					print
					print variables['cars']
					variables['cars']=[]
					amount_cars=[0,0,0,0,0]
					for i in range(len(Cbuttons)):
						amount_cars[i]+=Cbuttons[i].Lamount
					
					for i in range(len(amount_cars)):
						for j in range(amount_cars[i]):
							variables['cars'].append(i)	
						
					print variables['cars']
					print
					
					amount_weapons=[0,0,0,0,0]
					for i in range(len(Wbuttons)):
						amount_weapons[i]+=Wbuttons[i].Ramount
						
					amount_cars=[0,0,0,0,0]
					for i in range(len(Cbuttons)):
						amount_cars[i]+=Cbuttons[i].Lamount
					
					attack(variables,window,fullscreen,font,land,weapon,car,amount_weapons,amount_cars,weapons,cars)
					
					invade=False
	
		#draw graphics
		window.fill((0,0,100))
		
		name = font.render(land.name, True, (255,255,255), (0,0,100))
		nameRect = name.get_rect()
		nameRect.topleft = (100,100)
		window.blit(name, nameRect)
		
		defence = font.render('Defence:  '+str(land.defence), True, (255,255,255), (0,0,100))
		defenceRect = defence.get_rect()
		defenceRect.topleft = (100,150)
		window.blit(defence, defenceRect)
		
		population = font.render('Population:  '+str(land.population), True, (255,255,255), (0,0,100))
		populationRect = population.get_rect()
		populationRect.topleft = (100,200)
		window.blit(population, populationRect)
		
		window.blit(exit, exitRect)
		if exitRect.collidepoint(pygame.mouse.get_pos())==True:
			window.blit(buttonHIGHLIGHTED, exitRect)
			
		window.blit(buttonATTACK, ATTACKRect)
		if ATTACKRect.collidepoint(pygame.mouse.get_pos())==True:
			window.blit(buttonATTACK2, ATTACKRect)
		
		for i in Wbuttons:
		
			if i.WEAPON.image == 'nuclearmissile':
				window.blit(nuclearmissile,i.pos)
			if i.WEAPON.image == 'plaguemissile':
				window.blit(plaguemissile,i.pos)
			if i.WEAPON.image == 'electronicblackout':
				window.blit(electronicblackout,i.pos)
			if i.WEAPON.image == 'missile':
				window.blit(missile,i.pos)
			if i.WEAPON.image == 'waterballoon':
				window.blit(waterballoon,i.pos)
		
			#window.blit(i.WEAPON.image,i.pos)
			window.blit(plus,i.plus)
			if i.plus.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(plus2, i.plus)	
				
			window.blit(minus,i.minus)
			if i.minus.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(minus2, i.minus)
			
			num1 = font.render(str(i.Lamount), True, (255,255,255), (0,0,100))
			num1Rect = num1.get_rect()
			num1Rect.topright = (100,i.pos[1]+10)
			window.blit(num1, num1Rect)	
			
			num2 = font.render(str(i.Ramount), True, (255,255,255), (0,0,100))
			num2Rect = num2.get_rect()
			num2Rect.topleft = (250,i.pos[1]+10)
			window.blit(num2, num2Rect)	
			
		for i in Cbuttons:
		
			if i.car.image == 'plane':
				window.blit(plane,i.pos)
			if i.car.image == 'tank':
				window.blit(tank,i.pos)
			if i.car.image == 'helicopter':
				window.blit(helicopter,i.pos)
			if i.car.image == 'armouredtruck':
				window.blit(armouredtruck,i.pos)
			if i.car.image == 'bicycle':
				window.blit(bicycle,i.pos)

			#window.blit(i.car.image,i.pos)
			window.blit(plus,i.plus)
			if i.plus.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(plus2, i.plus)	
				
			window.blit(minus,i.minus)
			if i.minus.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(minus2, i.minus)
			
			num1 = font.render(str(i.Lamount), True, (255,255,255), (0,0,100))
			num1Rect = num1.get_rect()
			num1Rect.topright = (400,i.pos[1]+10)
			window.blit(num1, num1Rect)	
			
			num2 = font.render(str(i.Ramount), True, (255,255,255), (0,0,100))
			num2Rect = num2.get_rect()
			num2Rect.topleft = (550,i.pos[1]+10)
			window.blit(num2, num2Rect)	
				
		pygame.display.update()

def robberyplan(variables,window,fullscreen,font,target,men,man,gamename,banks,bank):

	#load images
	ninja=pygame.image.load('images/ninja.png')	
	mobster=pygame.image.load('images/mobster.png')	
	clown=pygame.image.load('images/clown.png')	
	ruffian=pygame.image.load('images/ruffian.png')	
	henchman=pygame.image.load('images/henchman.png')
	exit=pygame.image.load('images/buttonEXIT.png')	
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED.png')	
	buttonHIGHLIGHTED.set_colorkey((255,255,255))
	buttonATTACK=pygame.image.load('images/buttonROB.png')	
	buttonATTACK2=pygame.image.load('images/buttonROB2.png')
	plus=pygame.image.load('images/plus.png')
	plus2=pygame.image.load('images/plus2.png')	
	minus=pygame.image.load('images/minus.png')
	minus2=pygame.image.load('images/minus2.png')	
	
	exitRect=pygame.Rect(600,600,50,50)
	
	ATTACKRect=pygame.Rect(500,50,150,50)

	# count weapons
	
	amount_weapons=[0,0,0,0,0]
	for i in range(5):
		for j in variables['men']:
			if j==i:
				amount_weapons[i]+=1

	class weaponbutton():
		def __init__(self,WEAPON,pos,Ramount,Lamount,plus,minus):
			self.WEAPON=WEAPON
			self.pos=pos
			self.Ramount=Ramount
			self.Lamount=Lamount
			self.plus=plus
			self.minus=minus
	
	Wbuttons=[]
	for i in range(5):
		Wbuttons.append(weaponbutton(men[i],pygame.Rect(150,i*75+250,50,50),0,amount_weapons[i],pygame.Rect(225,i*75+270,10,10),pygame.Rect(115,i*75+270,10,10)))		
		
		'''		
	plusses=[]
	for i in range(5):
		plusses.append(pygame.Rect(160,210+i*100,10,10))
		'''
	
	invade=True
	while invade==True:
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				if exitRect.collidepoint(event.pos[0],event.pos[1])==True:
					invade=False
					
				for i in Wbuttons:
					if i.plus.collidepoint(event.pos[0],event.pos[1])==True:
						if i.Lamount>0:
							i.Lamount-=1
							i.Ramount+=1
					if i.minus.collidepoint(event.pos[0],event.pos[1])==True:
						if i.Ramount>0:
							i.Ramount-=1
							i.Lamount+=1
							
				if ATTACKRect.collidepoint(event.pos[0],event.pos[1])==True:
					print
					print variables['men']
					variables['men']=[]
					amount_weapons=[0,0,0,0,0]
					for i in range(len(Wbuttons)):
						amount_weapons[i]+=Wbuttons[i].Lamount
					
					for i in range(len(amount_weapons)):
						for j in range(amount_weapons[i]):
							variables['men'].append(i)	
						
					print variables['men']
					print
					
					rob(variables,window,fullscreen,font,target,men,amount_weapons,man)
					
					invade=False
	
		#draw graphics
		window.fill((0,0,100))

		defence = font.render('Securit:  '+str(target.defence), True, (255,255,255), (0,0,100))
		defenceRect = defence.get_rect()
		defenceRect.topleft = (100,100)
		window.blit(defence, defenceRect)
		
		population = font.render('Money:  '+str(target.money), True, (255,255,255), (0,0,100))
		populationRect = population.get_rect()
		populationRect.topleft = (100,150)
		window.blit(population, populationRect)
		
		window.blit(exit, exitRect)
		if exitRect.collidepoint(pygame.mouse.get_pos())==True:
			window.blit(buttonHIGHLIGHTED, exitRect)
			
		window.blit(buttonATTACK, ATTACKRect)
		if ATTACKRect.collidepoint(pygame.mouse.get_pos())==True:
			window.blit(buttonATTACK2, ATTACKRect)
		
		for i in Wbuttons:
		
			if i.WEAPON.image == 'henchman':
				window.blit(henchman,i.pos)
			if i.WEAPON.image == 'mobster':
				window.blit(mobster,i.pos)
			if i.WEAPON.image == 'ninja':
				window.blit(ninja,i.pos)
			if i.WEAPON.image == 'ruffian':
				window.blit(ruffian,i.pos)
			if i.WEAPON.image == 'clown':
				window.blit(clown,i.pos)
		
			#window.blit(i.WEAPON.image,i.pos)
			window.blit(plus,i.plus)
			if i.plus.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(plus2, i.plus)	
				
			window.blit(minus,i.minus)
			if i.minus.collidepoint(pygame.mouse.get_pos())==True:
				window.blit(minus2, i.minus)
			
			num1 = font.render(str(i.Lamount), True, (255,255,255), (0,0,100))
			num1Rect = num1.get_rect()
			num1Rect.topright = (100,i.pos[1]+10)
			window.blit(num1, num1Rect)	
			
			num2 = font.render(str(i.Ramount), True, (255,255,255), (0,0,100))
			num2Rect = num2.get_rect()
			num2Rect.topleft = (250,i.pos[1]+10)
			window.blit(num2, num2Rect)	
				
		pygame.display.update()		
			
def instructions(window,fullscreen):
	# open instructions

	f = open('instructions.txt','r')
	lines = f.readlines()
	
	f.close()
	
	#load images
	exit=pygame.image.load('images/buttonEXIT2.png')	
	exitRect=pygame.Rect(600,600,50,50)
	buttonHIGHLIGHTED=pygame.image.load('images/buttonHIGHLIGHTED2.png')	
	
	a=True
	
	scroll=0
	
	while a==True:
		#test for events
		for event in pygame.event.get():
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
				if event.key==K_F1:
					if fullscreen == True:
						fullscreen = False
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution)
					else:
						screenresolution=(700,700)
						window = pygame.display.set_mode(screenresolution,pygame.FULLSCREEN)
						fullscreen=True
				if event.key==K_UP:
					scroll+=100
				if event.key==K_DOWN:
					scroll-=100
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
			if event.type==MOUSEBUTTONDOWN:
				if exitRect.collidepoint(event.pos[0],event.pos[1])==True:
					menu(window, font, fullscreen)	
		
		#draw graphics
		window.fill((37,37,37))
			
		for i in range(len(lines)):
			text = font.render(lines[i][:-1], True, (255,255,255), (37,37,37))
			textRect = text.get_rect()
			textRect.topleft = (10,50*i+10+scroll)
			window.blit(text, textRect)
		
		pygame.draw.rect(window, (37,37,37), (0, 500, 700,200))	
			
		window.blit(exit, exitRect)
		if exitRect.collidepoint(pygame.mouse.get_pos())==True:
			window.blit(buttonHIGHLIGHTED, exitRect)	
				
		pygame.display.update()				

def attack(variables,window,fullscreen,font,land,weapon,car,amount_weapons,amount_cars,weapons,cars):
	force=0
	for i in range(len(weapons)):
		force+=weapons[i].damage*amount_weapons[i]
		
	for i in range(len(cars)):
		force+=cars[i].damage*amount_cars[i]	
		
	succes=False	
	if land.defence > force:
		if random.randint(0,10)==1:
			succes=True
	else:
		if random.randint(0,10)!=1:
			succes=True
	
	# write reults
	screenresolution=(700,700)
	window.fill((0,0,100))
					
	if succes==True:
		variables['countries inslaved'].append(land.name)
		result = font.render('Invasion succesful!', True, (255,255,255), (0,0,100))
	else:
		result = font.render('Invasion failed.', True, (255,255,255), (0,0,100))
	resultRect = result.get_rect()
	resultRect.centerx = screenresolution[0]/2
	resultRect.centery = screenresolution[1]/2
	window.blit(result, resultRect)
	
	pygame.display.update()
	time.sleep(2)

def rob(variables,window,fullscreen,font,target,men,amount_weapons,man):
	force=0
	for i in range(len(men)):
		force+=men[i].damage*amount_weapons[i]
		
	succes=False	
	if target.defence > force:
		succes=False
	else:
		if random.randint(0,10)!=1:
			succes=True
	
	# write reults
	screenresolution=(700,700)
	window.fill((0,0,100))
					
	if succes==True:
		variables['banks robbed'].append(target.name)
		variables['cash']+=target.money
		result = font.render('Robbery succesful!', True, (255,255,255), (0,0,100))
	else:
		result = font.render('Robbery failed.', True, (255,255,255), (0,0,100))
	resultRect = result.get_rect()
	resultRect.centerx = screenresolution[0]/2
	resultRect.centery = screenresolution[1]/2
	window.blit(result, resultRect)
	
	pygame.display.update()
	time.sleep(2)	
					
menu(window, font, fullscreen)	